program project1;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes,
  { you can add units after this }
  SysUtils, Dialogs, laz2_dom,
  laz2_xmlread, fpsxmlcommon;


procedure RebuildChildNodes(ANode: TDOMNode; var AText: string);
var
  nodeName: string;
  s: string;
  i: integer;
begin
  if ANode = nil then
    exit;
  while ANode <> nil do
  begin
    nodeName := ANode.NodeName;
    if nodeName = '#text' then
      AText := AText + ANode.NodeValue
    else
    begin
      s := '';
      for i := 0 to ANode.Attributes.Length - 1 do
        s := Format('%s %s="%s"', [s, ANode.Attributes.Item[i].NodeName, ANode.Attributes.Item[i].NodeValue]);
      AText := Format('%s<%s%s>', [AText, nodeName, s]);
      s := '';
      RebuildChildNodes(ANode.FirstChild, s);
      if s <> '' then
        AText := Format('%s%s</%s>', [AText, s, nodeName]);
    end;
    ANode := ANode.NextSibling;
  end;
end;


var
  doc: TXMLDocument = nil;
  sheet_node: TDOMNode;
  table_node: TDOMNode;
  row_node: TDOMNode;
  cell_node: TDOMNode;
  data_node: TDOMNode;
  nodeName: string;
  s: string;
begin
  try
    ReadXMLFile(doc, 'test.xml');
    sheet_node := doc.DocumentElement.FindNode('Worksheet');
    if sheet_node = nil then
      exit;
    table_node := sheet_node.FindNode('Table');
    row_node := table_node.FirstChild;
    while row_node <> nil do
    begin
      nodeName := row_node.NodeName;
      if nodeName = 'Row' then
      begin
        cell_node := row_node.FirstChild;
        while cell_node <> nil do
        begin
          nodeName := cell_node.NodeName;
          if nodeName = 'Cell' then
          begin
            data_node := cell_node.FirstChild;
            while data_node <> nil do
            begin
              nodeName := data_node.NodeName;
              if nodeName = 'Data' then
              begin
                s := GetAttrValue(data_node, 'ss:Type');
                if (s = 'String') or (s = 'Number') then
                begin
                  WriteLN(Format('GetNodeValue(data_node): "%s"', [GetNodeValue(data_node)]));
                  WriteLN(Format('data_node.TextContent: "%s"', [data_node.TextContent]));
                  RebuildChildNodes(data_node, s);
                  WriteLN('After rebuild: '+s);
                  WriteLN(Format('GetNodeValue(data_node): "%s"', [GetNodeValue(data_node)]));
                  WriteLN(Format('data_node.TextContent: "%s"', [data_node.TextContent]));

                  ReadLN;
                end
                else
                  WriteLN('');
              end;
              data_node := data_node.NextSibling;
            end;
          end;
          cell_node := cell_node.NextSibling;
        end;
      end;
      row_node := row_Node.NextSibling;
    end;
  finally
    doc.Free;
  end;
end.
